QGIS Application - Bug report #20067
Duplicate feature action fails with PostgreSQL error message
2018-10-10 11:52 AM - Andreas Neumann

Status: Closed

Priority: Normal

Assignee: David Signer

Category: Actions

Affected QGIS version:3.3(master) Regression?: Yes
Operating System: any Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 27889
Description

The Duplicate feature action that is available from the Actions menu of a feature form is currently broken in QGIS 3.2 and QGIS master. It
still work fine in QGIS 3.0.x

The issues might be specific to my project and data structure.

The affected column that causes issues also has a default value attached, that is created by a custom Python expression.

In version 3.2.x nothing happens when trying to digitize the duplicate, in 3.3x there is the following error message:

CRITICAL: Layer EWS_Anlage: PostGIS-Fehler beim Attributhinzufligen: ERROR: value too long for type character varying(7).

However, the values that are generated by the custom python expression function are exactly 7 characters long.

Could it be that in 3.2 and master it is trying to commit the expression code instead of the expression result for default values?

David should have our project file and DB structure, but | can submit it to others on request.

Thanks!

Associated revisions

Revision d26848e9 - 2018-10-15 09:12 AM - David Signer

right order of priorities

by getting the value - if it's unique, first getting the defaults before creating an unique value.

Fix #20067

History

#1 - 2018-10-10 11:54 AM - Andreas Neumann

The concerned column is most likely the one named "anlage_nr" with the following definition:
anlage_nr character varying(7) COLLATE pg_catalog."default" NOT NULL,
#2 - 2018-10-10 12:25 PM - David Signer
- Assignee set to David Signer

#3 - 2018-10-11 10:16 AM - David Signer

I've been able to reproduce.

Your expression:

get_ews_anlage_gemeinde_formatted() || '.' || get_ews_anlage_nr( get_ews_anlage_gemeinde_formatted() )

is displayed as invalid on my build. Not sure how it is on the 3.0.x - can you check?

Has there been a change in the call of the functions like e.g. with an @7?

#4 - 2018-10-11 10:25 AM - David Signer

Just seen another thing. Could it be that an error is given back and then the error message is tried to write into the field?

But I'll continue research...

#5 - 2018-10-11 11:45 AM - David Signer

fyi:

Found the error. It's because it creates a value like "03.0108_1" in createUniqueValue called by createFeature instead of creating a new default value by

expression.

#6 - 2018-10-11 11:47 AM - Andreas Neumann

Good catch - thanks!

In 3.0 this still worked fine. So something in 3.2 or master introduced this problem.

Can you fix that?

Many thanks and have a nice weekend?

#7 - 2018-10-11 11:51 AM - David Signer

Yes | will fix it. But | have to continue on Monday. Hope you don't mind.

#8 - 2018-10-11 12:07 PM - Andreas Neumann

that's fine - thanks!

#9 - 2018-10-16 03:18 PM - David Signer
- % Done changed from 0 to 100
- Status changed from Open to Closed

2025-04-27 2/3



Applied in changeset commit:qgis|d26848e97746ccab3a8ac5c0a9cc56db63e34501.

Files
ews_anlage_create-table-statement.txt 7.04 KB 2018-10-10 Andreas Neumann
ews_custom-python-expression.py 1.13 KB 2018-10-10 Andreas Neumann
